
// variables globales

int CommandeOldG=0;
int CommandeOldD=0;
int ErreurOldG=0;
int ErreurOldD=0;
int codeurOldG=0;
int codeurOldD=0;

// Prototype des fonctions


void InitPI(void);
int PI_gauche (int ConsigneG, int codeurG);
int PI_droit  (int ConsigneD, int codeurD);
int CalculeVitesseG(int codeurG);
int CalculeVitesseD(int codeurD);
void CommandeMoteurG(int MoteurG);
void CommandeMoteurD(int MoteurD);

//------------------------------------------------------------------------------------	

void InitPI(void)
{

	CommandeOldG=0;
	CommandeOldD=0;
	ErreurOldG=0;
	ErreurOldD=0;
}

int PI_gauche (int ConsigneG, int VitesseG)
{
	// Variables
	int CommandeG=0;		// Commande des moteurs
			// Vitesse de rotation mesure des roues
	int ErreurG;			// Erreur (Epsilon)

	// Calcul de l'asservissemnt en vitesse (PI)

	ErreurG = ConsigneG-VitesseG;										// Calcule l'erreur Epsilon

//	CommandeG = (int)(CommandeOldG - (ErreurG*0.5) + ErreurOldG);		// Calcule le correcteur et la commande U
	CommandeG = (int)(CommandeOldG + 1.3696493*ErreurG - 0.9504239*ErreurOldG);		// Calcule le correcteur et la commande U
	ErreurOldG=ErreurG;													// Mmorise erreur

	return (CommandeG);									// Mmorise la vitesse
}


//------------------------------------------------------------------------------------	
int PI_droit (int ConsigneD, int VitesseD)
{
	// Variables
	int CommandeD=0;		// Commande des moteurs

	int ErreurD;			// Erreur (Epsilon)

	ErreurD = ConsigneD -VitesseD;										// Calcule l'erreur Epsilon

//	CommandeD = (int)(CommandeOldD - (ErreurD*0.5) + ErreurOldD);		// Calcule le correcteur et la commande U
	CommandeD = (int)(CommandeOldD + 1.3696493*ErreurD - 0.9504239*ErreurOldD);		// Calcule le correcteur et la commande U

	ErreurOldD=ErreurD;													// Mmorise erreur

	return (CommandeD);

}




//------------------------------------------------------------------------------------

int CalculeVitesseG(int codeurG)
{
	int VitesseG;
	if(codeurOldG<=codeurG)		VitesseG= codeurG - codeurOldG; else VitesseG = (65536-codeurOldG)+codeurG;		// Vrifie les dpassements
	if (!sens_G)		VitesseG=-VitesseG; 																		// Vrifie le sens
	codeurOldG=codeurG;		// Mmorise les anciennes valeurs
	return (VitesseG);
}

//------------------------------------------------------------------------------------

int CalculeVitesseD(int codeurD)
{
	int VitesseD;
	if(codeurOldD<=codeurD)		VitesseD= codeurD - codeurOldD; else VitesseD = (65536-codeurOldD)+codeurD;		// Vrifie les dpassements
	if (sens_D)		VitesseD=-VitesseD; 																		// Vrifie le sens
	codeurOldD=codeurD;		// Mmorise les anciennes valeurs
	return (VitesseD);
}


void CommandeMoteurG(int Com)
{
	// Seuille les commandes

	if (Com> 1023) Com= 1023;						// Moteur gauche
	if (Com<-1023) Com=-1023;
	CommandeOldG=Com;	
	Moteurgauche (Com);
	
}


void CommandeMoteurD(int Com)
{
	if (Com> 1023) Com= 1023;						// Moteur gauche
	if (Com<-1023) Com=-1023;
	CommandeOldD=Com;	
	Moteurdroit(Com);
}
