#ifndef __CONFIGPORT_H__
#define __CONFIGPORT_H__

// Fichier d'attribution des entres sorties

// Port E/S supplmentaires

#define AN0		PORTAbits.RA0		// Convertisseur AN0 ou E/S ou Led
#define AN1		PORTAbits.RA1		// Convertisseur AN1 ou E/S ou Led
#define AN2		PORTAbits.RA2		// Convertisseur AN1 ou E/S ou Led
#define AN3		PORTAbits.RA3		// Convertisseur AN1 ou E/S ou Led
#define AN4		PORTAbits.RA5		// Convertisseur AN1 ou E/S ou Led
#define Jack	PORTBbits.RB0		// E/S ou interruption ou Led

// Commande des moteurs

#define DIR_D	PORTBbits.RB6		// Sens du moteur droit
#define DIR_G	PORTBbits.RB7		// Sens du moteur gauche
#define PWM_G	PORTCbits.CCP1		// PWM du moteur gauche
#define PWM_D	PORTCbits.CCP2		// PWM du moteur droit

// Gestion des codeurs

#define sens_D	PORTBbits.RB4 		// Sens de la roue droite (0->avant; 1->arriere)
#define sens_G	PORTBbits.RB5 		// Sens de la roue gauche (0->arriere; 1->avant)
#define ChA_G	PORTAbits.RA4		// Impulsion du codeur gauche
#define ChA_D	PORTCbits.T1CKI		// Impulsion du codeur droit

// I2C

#define SCL	PORTCbits.SCL			// BUS IC CLK
#define SDA	PORTCbits.SDA			// BUS IC SDA

// Connecteur crve-ballon

#define CB_RB3	PORTBbits.RB3			// ???
#define CB_RC5	PORTCbits.RC5			// ???

// Multiplexage des capteurs de ligne

#define	Data	PORTD				// Donnes
#define Data0	PORTDbits.RD0		// Donnes de 0  7
#define Data1	PORTDbits.RD1
#define Data2	PORTDbits.RD2
#define Data3	PORTDbits.RD3
#define Data4	PORTDbits.RD4
#define Data5	PORTDbits.RD5
#define Data6	PORTDbits.RD6
#define Data7	PORTDbits.RD7
#define Ad0	PORTEbits.RE1			// Adresse Ad0
#define Ad1	PORTEbits.RE2			// Adresse Ad1



#endif
