// Programme principal du robot de Vierzon 2007 
// Version 1.0
// 
// Asservissement en vitesse
// Asservissement en position
//
// Ralis par 2 branquignols


//************************** fichier d'entete **********************************/

#include <p18f452.h>
#include <delays.h>
#include "ConfigPorts.h"
#include "minus.h"
#include "Strategie.h"
#include "AnalyseLigne.h"







//************ Instruction de configuration du pic et de l'horloge *************/

#pragma config WDT = OFF	// Pas de  watchdog
#pragma config OSC = HS		// Quartz HS pour un quartz 20MHz



//************debut du programme************//

void main(void)
{
	char TabCapt[32];					// Tableau qui mmorise les capteurs
	int Pos_Interm;
	int val;

	ConfigProcess();					// Configure le microcontrolleur


	while (1)
	{
			CB_RC5=!CB_RC5;
			TableauCapteur(TabCapt);
			Pos_Interm=AnalyseLigne(TabCapt);		// Calcule le barycentre

			INTCONbits.GIE=0;					// interdiction gnrale des interruptions non masques			
			Pos=Pos_Interm;
			INTCONbits.GIE=1;					// Autorisation gnrale des interruptions non masques			
			SendInt(Pos_Interm);
			WriteUSART(13);
	}
}









